#!/bin/bash

set -u
set -e

. ../duilder.conf

RP_VER="20200609"

docker="podman"

sed \
	-e "s|@@RP_VER@@|${RP_VER}|" \
	Dockerfile-postgresql.tmpl > Dockerfile-postgresql
if [ "`${docker} images -q rocketgit/rocketgit-postgresql:${RP_VER}`" = "" ]; then
	echo "Building rocketgit-postgresql (${RP_VER})..."
	${docker} build \
		--net container \
		--tag="rocketgit/rocketgit-postgresql:${RP_VER}" \
		-f Dockerfile-postgresql \
		.
	${docker} tag "rocketgit/rocketgit-postgresql:${RP_VER}" \
		"rocketgit/rocketgit-postgresql:latest"
fi


echo "Building rocketgit (fedora)..."
sed -e "s|@@VER@@|${VER}|" Dockerfile-rocketgit.tmpl > Dockerfile-rocketgit
${docker} build \
	--tag="rocketgit/rocketgit:${VER}" \
	-f Dockerfile-rocketgit \
	.
${docker} tag "rocketgit/rocketgit:${VER}" "rocketgit/rocketgit:latest"


# This is not working because alpine's chmod does not know about --reference
exit 0
echo "Building rocketgit (alpine)..."
sed -e "s|@@VER@@|${VER}|" Dockerfile-rocketgit-alpine.tmpl > Dockerfile-rocketgit-alpine
${docker} build \
	--tag="rocketgit/rocketgit-alpine:${VER}" \
	-f Dockerfile-rocketgit-alpine \
	.
${docker} tag "rocketgit/rocketgit-alpine:${VER}" "rocketgit/rocketgit-alpine:latest"


