<?php
require_once($INC . "/util.inc.php");
require_once($INC . "/log.inc.php");
require_once($INC . "/sql.inc.php");
require_once($INC . "/user.inc.php");
require_once($INC . "/repo.inc.php");
require_once($INC . "/bug.inc.php");
require_once($INC . "/keys.inc.php");
require_once($INC . "/prof.inc.php");
require_once($INC . "/watch.inc.php");

/*
 * Main entry point
 */
function rg_api($db, &$a, $json)
{
	rg_prof_start('api');
	rg_log_enter('api: json=' . rg_array2string($json));

	$ret = array();
	while (1) {
		if (!isset($json['cmd'])) {
			$ret['error'] = '\'cmd\' parameter not present';
			break;
		}

		$ret['cmd'] = $json['cmd'];

		if (isset($json['opaque']))
			$ret['opaque'] = $json['opaque'];

		// Needed for logging
		rg_stats_conns_set('cmd', $json['cmd']);

		if (isset($json['user'])) {
			$a['target_ui'] = rg_user_info($db, 0, $json['user'], '');
		} else if (isset($json['uid'])) {
			$a['target_ui'] = rg_user_info($db, $json['uid'], '', '');
		} else {
			$a['target_ui'] = $a['login_ui'];
		}

		rg_stats_conns_set('uid', $a['target_ui']['uid']);

		if (strncmp($json['cmd'], 'user', 4) == 0) {
			$ret = array_merge($ret, rg_user_api($db, $a, $json));
			break;
		}

		if (strncmp($json['cmd'], 'repo', 4) == 0) {
			$ret = array_merge($ret, rg_repo_api($db, $a, $json));
			break;
		}

		$ret['error'] = 'invalid command';
		break;
	}

	rg_log_exit();
	rg_prof_end('api');
	return $ret;
}

