<?php
error_reporting(E_ALL | E_STRICT);
ini_set("track_errors", "On");

$INC = dirname(__FILE__) . "/../inc";
require_once(dirname(__FILE__) . "/config.php");
require_once($INC . "/init.inc.php");
require_once($INC . "/util.inc.php");
require_once($INC . "/log.inc.php");
require_once($INC . "/cache.inc.php");

rg_log_set_file("cache.log");

$rg_no_db = TRUE;
require_once("common.php");

$rg_cache_enable = TRUE;
$rg_cache_debug = TRUE;


rg_log('');
rg_log('Seting a var in core...');
rg_cache_core_set("a::b::c", "1");


rg_log('');
rg_log('Testing core_get...');
$e = "1";
$r = rg_cache_core_get("a::b::c");
if ($r !== $e) {
	rg_log_ml('rg_cache: ' . print_r($rg_cache, TRUE));
	rg_log("[$r] != [$e]!");
	exit(1);
}

rg_log('');
rg_log('Testing unset on a dir (not value)...');
rg_cache_core_unset("a::b");
$r = rg_cache_core_get('a');
if (!empty($r)) {
	rg_log_ml('rg_cache: ' . print_r($rg_cache, TRUE));
	rg_log("unsetting a dir is not working!");
	exit(1);
}

rg_log('');
rg_log('Getting an invalid var...');
$e = FALSE;
$r = rg_cache_core_get("x::y::z");
if ($r !== $e) {
	rg_log_ml('rg_cache: ' . print_r($rg_cache, TRUE));
	rg_log("r must be FALSE!");
	exit(1);
}

rg_log('');
rg_log('Testing unsetting of an invalid var...');
rg_cache_core_unset("x::y::z");
$e = FALSE;
$r = rg_cache_core_get("x::y::z");
if ($r !== $e) {
	rg_log_ml('rg_cache: ' . print_r($rg_cache, TRUE));
	rg_log("r must be FALSE ($r)!");
	exit(1);
}

////////////////////////////////// Arrays

rg_cache_core_apush("v", "1");
rg_cache_core_apush("v", "2");
rg_cache_core_apush("v", "aa");
$e = "0=[1] 1=[2] 2=[aa]";
$r = rg_cache_core_adump("v");
if ($r !== $e) {
	rg_log_ml('rg_cache: ' . print_r($rg_cache, TRUE));
	rg_log("[$r] != [$e]!");
	exit(1);
}

$e = "aa";
$r = rg_cache_core_apop("v");
if ($r !== $e) {
	rg_log_ml('rg_cache: ' . print_r($rg_cache, TRUE));
	rg_log("[$r] != [$e]!");
	exit(1);
}

$e = "1";
$r = rg_cache_core_ashift("v");
if ($r !== $e) {
	rg_log_ml('rg_cache: ' . print_r($rg_cache, TRUE));
	rg_log("[$r] != [$e]!");
	exit(1);
}

$e = FALSE;
$r = rg_cache_core_ashift("v");
$r = rg_cache_core_ashift("v");
if ($r !== $e) {
	rg_log_ml('rg_cache: ' . print_r($rg_cache, TRUE));
	rg_log("r is not FALSE ($r)!");
	exit(1);
}


rg_log('');
rg_log('Testing set/get with a small timeout');
$rg_cache_timeout = 1;
rg_cache_set('test::A', 'A', 0);
rg_cache_set('test::B', 'B', 0);
rg_cache_sleep();
$rg_cache = array();
rg_cache_get('test::B');
$rg_cache_timeout = 6000;
$r = rg_cache_get('test::A');
if ($r !== 'A') {
	rg_log('Small timeout test failed! r=' . print_r($r, TRUE));
	exit(1);
}


rg_log('');
rg_log('Testing timeout');
$rg_cache_timeout = 1;
rg_cache_sleep();
$rg_cache = array();
$rg_cache_timeout = 10;
$r = rg_cache_get('bla::bla');
if ($r !== FALSE) {
	rg_log('Timeout test failed! r=' . print_r($r, TRUE));
	exit(1);
}


rg_log('');
rg_log_enter('Testing a key that contains \n');
$k = 'aaa::bbb' . "\n";
rg_cache_set($k, 'value', 0);
$r = rg_cache_get($k);
if (strcmp($r, 'value') != 0) {
	rg_log_ml('r:' . print_r($r, TRUE));
	rg_log('Strange keys does not work correctly!');
}
rg_log_exit();

rg_log("OK!");
?>
