<?php
// This will be run from git_log1.sh

error_reporting(E_ALL | E_STRICT);
ini_set("track_errors", "On");

$INC = dirname(__FILE__) . "/../inc";
require_once(dirname(__FILE__) . "/config.php");
require_once($INC . "/init.inc.php");
require_once($INC . "/git.inc.php");

rg_log_set_file(dirname(__FILE__) . "/git_log1.log");

$rg_no_db = TRUE;
require_once("common.php");

$rg_git_debug = 100;
$patch_limit = rg_git_patch_limit($db);

rg_log('');
rg_log_enter('Testing rg_git_log...');
$path = dirname(__FILE__) . "/git_log1/.git";
$max = 0;
$from = "";
$to = "";
$also_patch = TRUE;
$r = rg_git_log($path, $max, $from, $to, $also_patch, $patch_limit);
if ($r === FALSE) {
	rg_log("Cannot generate log (" . rg_git_error() . ")!");
	exit(1);
}

$final = '';
foreach ($r as $commit_index => $commit_info) {
	$a = rg_git_diff('uniq-id', $commit_info['files'],
		dirname(__FILE__) . "/git_log1.tmpl");
	if ($a === FALSE) {
		rg_log("Error calling rg_git_diff for commit_index $commit_index"
			. " (" . rg_git_error() . ")!");
		exit(1);
	}

	$final .= $a;
}
file_put_contents(dirname(__FILE__) . "/git_log1.final", $final);
rg_log_exit();


rg_log('OK!');
?>
