<?php
error_reporting(E_ALL);


$INC = __DIR__ . '/../../inc';
require_once $INC . '/ldap.inc.php';

$r = rg_ldap_connect('ldap://127.0.0.1:65001');
if ($r['ok'] !== 1) {
	echo 'Cannot connect: ' . $r['errmsg'] . "\n";
	exit(1);
}

$con = $r['con'];
$r = rg_ldap_bind($con, 'cn=Manager,dc=my-domain,dc=com', 'aaaaaa');
if ($r['ok'] !== 1) {
	echo 'Cannot bind: ' . $r['errmsg'] . "\n";
	exit(1);
}

$org = time();

$a = array(
	'objectClass' => 'organization',
	'o' => 'Org-' . $org
);
$r = rg_ldap_add($con, 'o=Org-' . $org . ',dc=my-domain,dc=com', $a);
if ($r['ok'] !== 1) {
	echo 'Cannot add: ' . $r['errmsg'] . "\n";
	exit(1);
}

$a = array(
	'objectClass' => 'groupOfNames',
	'cn' => 'group3',
	'member' => 'uid=invalid,ou=People,dc=my-domain,dc=com'
);
$r = rg_ldap_add($con, 'cn=groupx,ou=Group,dc=my-domain,dc=com', $a);
if ($r['ok'] !== 1) {
	echo 'Cannot add: ' . $r['errmsg'] . "\n";
	exit(1);
}

echo "OK!\n";

?>

