#!/bin/bash

set -e
set -u

export GIT_SSH_COMMAND="ssh -o ControlMaster=no -o IdentityFile=${PWD}/keys/${RG_SSH_KEY} -o IdentitiesOnly=yes"

echo "Cloning repo..."
rm -rf wh_cloud.git
git clone "${1}" wh_cloud.git
cd wh_cloud.git
cat >appspec.yml <<EOF
version: 0.0
os: linux
files:
  - source: /index.html
    destination: /var/www/html/
hooks:
  BeforeInstall:
    - location: scripts/install_dependencies
      timeout: 3
      runas: root
    - location: scripts/start_server
      timeout: 3
      runas: root
  ApplicationStop:
    - location: scripts/stop_server
      timeout: 3
      runas: root
EOF
git add appspec.yml
git commit -a -m "a commit"

echo "Pushing..."
git push origin master
